/*
 * Created on 01.12.2004
 *
 * Copyright (c) 2004
 * Telecooperation Office (TecO), Universitaet Karlsruhe (TH), Germany.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above
 *    copyright notice, this list of conditions and the following
 *    disclaimer in the documentation and/or other materials provided
 *    with the distribution.
 * 3. Neither the name of the Universitaet Karlsruhe (TH) nor the names
 *    of its contributors may be used to endorse or promote products
 *    derived from this software without specific prior written
 *    permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
 * OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 * 
 */
package edu.teco.particles.pComponent;

import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;

import javax.swing.Action;
import javax.swing.JButton;
import javax.swing.JFormattedTextField;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JSpinner;
import javax.swing.event.TableModelEvent;
import javax.swing.event.TableModelListener;
import javax.swing.event.TreeSelectionEvent;
import javax.swing.event.TreeSelectionListener;
import javax.swing.tree.TreePath;

import edu.teco.particles.libParticle.ParticleSrcId;
import edu.teco.particles.pComponent.io.ParticlePacketListener;
import edu.teco.particles.pComponent.io.ParticlePacketsEvent;
import edu.teco.particles.pComponent.sender.*;

/**
 * A ParticleComponent to send Data to a particle.
 */
public class Sender extends JPanel implements ParticlePacketListener,
    TreeSelectionListener
{

  private JFormattedTextField receiverTextField = null;

  private JLabel              jLabel            = null;

  private JLabel              jLabel1           = null;

  private JFormattedTextField senderTextField   = null;

  private JLabel              jLabel2           = null;

  private TupleEditor         tupleEditor       = null;

  private JButton             sendButton           = null;

  /**
   * creates a new Sender Bean.
   */
  public Sender()
  {
    super();
    initialize();
  }

  /**
   * This method initializes this
   * 
   * @return void
   */
  private void initialize()
  {
    GridBagConstraints gridBagConstraints11 = new GridBagConstraints();
    GridBagConstraints gridBagConstraints22 = new GridBagConstraints();
    jLabel2 = new JLabel();
    jLabel1 = new JLabel();
    jLabel = new JLabel();
    GridBagConstraints gridBagConstraints1 = new GridBagConstraints();
    GridBagConstraints gridBagConstraints2 = new GridBagConstraints();
    GridBagConstraints gridBagConstraints3 = new GridBagConstraints();
    GridBagConstraints gridBagConstraints4 = new GridBagConstraints();
    GridBagConstraints gridBagConstraints5 = new GridBagConstraints();
    GridBagConstraints gridBagConstraints21 = new GridBagConstraints();
    this.setLayout(new GridBagLayout());
    this.setSize(390, 348);
    gridBagConstraints1.gridx = 1;
    gridBagConstraints1.gridy = 0;
    gridBagConstraints1.weightx = 1.0;
    gridBagConstraints1.fill = java.awt.GridBagConstraints.HORIZONTAL;
    gridBagConstraints1.insets = new java.awt.Insets(5, 10, 5, 10);
    gridBagConstraints2.gridx = 0;
    gridBagConstraints2.gridy = 0;
    gridBagConstraints2.insets = new java.awt.Insets(5, 10, 5, 10);
    gridBagConstraints2.anchor = java.awt.GridBagConstraints.WEST;
    jLabel.setText("Sender ID:");
    gridBagConstraints3.gridx = 0;
    gridBagConstraints3.gridy = 1;
    gridBagConstraints3.insets = new java.awt.Insets(5, 10, 5, 10);
    gridBagConstraints3.anchor = java.awt.GridBagConstraints.WEST;
    jLabel1.setText("Receiver ID:");
    gridBagConstraints4.gridx = 1;
    gridBagConstraints4.gridy = 1;
    gridBagConstraints4.weightx = 1.0;
    gridBagConstraints4.fill = java.awt.GridBagConstraints.HORIZONTAL;
    gridBagConstraints4.insets = new java.awt.Insets(5, 10, 5, 10);
    gridBagConstraints5.gridx = 0;
    gridBagConstraints5.gridy = 2;
    gridBagConstraints5.insets = new java.awt.Insets(5, 10, 5, 10);
    gridBagConstraints5.anchor = java.awt.GridBagConstraints.WEST;
    jLabel2.setText("Sequence Number:");
    gridBagConstraints21.gridx = 0;
    gridBagConstraints21.gridy = 3;
    gridBagConstraints21.gridwidth = 2;
    gridBagConstraints21.fill = java.awt.GridBagConstraints.BOTH;
    gridBagConstraints21.insets = new java.awt.Insets(10, 10, 10, 10);
    gridBagConstraints22.gridx = 1;
    gridBagConstraints22.gridy = 4;
    gridBagConstraints22.anchor = java.awt.GridBagConstraints.EAST;
    gridBagConstraints22.insets = new java.awt.Insets(10, 10, 10, 10);
    gridBagConstraints11.gridx = 1;
    gridBagConstraints11.gridy = 2;
    gridBagConstraints11.anchor = java.awt.GridBagConstraints.EAST;
    gridBagConstraints11.insets = new java.awt.Insets(0, 0, 0, 10);
    this.add(getSenderTextField(), gridBagConstraints1);
    this.add(jLabel, gridBagConstraints2);
    this.add(jLabel1, gridBagConstraints3);
    this.add(getReceiverTextField(), gridBagConstraints4);
    this.add(jLabel2, gridBagConstraints5);
    this.add(getTupleEditor(), gridBagConstraints21);
    this.add(getSendButton(), gridBagConstraints22);
    this.add(getSequenceNumberSpinner(), gridBagConstraints11);

  }

  public void particlePackets(ParticlePacketsEvent e)
  {
    // TODO Auto-generated method stub

  }

  /**
   * @name SocketProperty
   * @brief The Socket from which packets are recvd. @{
   */
  private SocketThread _socket;

  public SocketThread getSocket()
  {
    return _socket;
  }

  public void setSocket(SocketThread socket)
  {
    _socket = socket;
    socket.addParticlePacketListener(this);
    getSenderTextField().setValue(socket.getSrcId());
    getReceiverTextField().setValue(socket.getSrcId());

    // update the action which should be performed on button click.
    _currentAction = null;
    getSendButton().setAction(_getCurrentAction());
  }

  /** @} */

  /**
   * This method initializes jFormattedTextField
   * 
   * @return javax.swing.JFormattedTextField
   */
  private JFormattedTextField getReceiverTextField()
  {
    if (receiverTextField == null)
    {
      receiverTextField = new JFormattedTextField(createIdFormatter());

      receiverTextField.addPropertyChangeListener("value",
          new java.beans.PropertyChangeListener() {
            public void propertyChange(java.beans.PropertyChangeEvent e)
            {
              if (e.getNewValue() instanceof ParticleSrcId)
              {
                getTupleEditor().getPacket().setDestinationId(
                    (ParticleSrcId) e.getNewValue());
              }
            }
          });
    }
    return receiverTextField;
  }

  /**
   * This method initializes jFormattedTextField1
   * 
   * @return javax.swing.JFormattedTextField
   */
  private JFormattedTextField getSenderTextField()
  {
    if (senderTextField == null)
    {
      senderTextField = new JFormattedTextField(createIdFormatter());
      senderTextField.addPropertyChangeListener("value",
          new java.beans.PropertyChangeListener() {
            public void propertyChange(java.beans.PropertyChangeEvent e)
            {
              getSocket().setSrcId((ParticleSrcId) e.getNewValue());
            }
          });
    }
    return senderTextField;
  }

  /** creates a MaskFormatter for editing srcIds */
  protected DotFormatter createIdFormatter()
  {
    DotFormatter form = null;

    form = new DotFormatter();

    return form;
  }

  /**
   * This method initializes tupleEditor
   * 
   * @return edu.teco.particles.pComponent.sender.TupleEditor
   */
  private TupleEditor getTupleEditor()
  {
    if (tupleEditor == null)
    {
      tupleEditor = new TupleEditor();
    }
    return tupleEditor;
  }

  /**
   * This method initializes sendButton
   * 
   * @return javax.swing.JButton
   */
  private JButton getSendButton()
  {
    if (sendButton == null)
    {
      sendButton = new JButton();
      sendButton.setText("Send");
      sendButton.setFont(new java.awt.Font("Verdana,Tahoma", java.awt.Font.PLAIN,
          18));
      sendButton.setAction(_getCurrentAction());
    }
    return sendButton;
  }

  protected Action _currentAction;

  protected Action _getCurrentAction()
  {
    if (isSendAcked())
    {
      _currentAction = new AckedSendAction(getSocket(), getTupleEditor()
          .getPacket());
    }
    else if (isSendAdressed())
    {
      _currentAction = new AdressedSendAction(getSocket(), getTupleEditor()
          .getPacket());
    }
    else
    {
      _currentAction = new DefaultSendAction(getSocket(), getTupleEditor()
          .getPacket());
    }

    assert (_currentAction != null);

    return _currentAction;
  }

  /*
   * ========================================================================
   * Bean Properties.
   * ========================================================================
   */
  protected boolean _sendAcked = false;

  public boolean isSendAcked()
  {
    return _sendAcked;
  };

  public void setSendAcked(boolean state)
  {
    _sendAcked = state;
    getSendButton().setAction(_getCurrentAction());
  }

  protected boolean _sendAdressed = false;

  public boolean isSendAdressed()
  {
    return _sendAdressed;
  }

  public void setSendAdressed(boolean state)
  {
    _sendAdressed = state;
    getSendButton().setAction(_getCurrentAction());
  }

  protected int _timeout = 20;

  public int getTimeout()
  {
    return _timeout;
  }

  public void setTimeout(int timeout)
  throws IllegalArgumentException 
  {
    if (timeout<0)
      throw new IllegalArgumentException("no negative Timeout.");
    _timeout = timeout;
    getSocket().setRetry((short) getRetries(), (long) getTimeout());
  }

  protected int    _retries = 100;

  private JSpinner sequenceNumberSpinner = null;

  public int getRetries()
  {
    return _retries;
  }

  public void setRetries(int retries)
  throws IllegalArgumentException
  {
    if (retries<0)
      throw new IllegalArgumentException("no negative retries.");
    _retries = retries;
    getSocket().setRetry((short) getRetries(), (long) getTimeout());
  }

  /**
   * This method initializes sequenceNumberSpinner
   * 
   * @return javax.swing.JSpinner
   */
  private JSpinner getSequenceNumberSpinner()
  {
    if (sequenceNumberSpinner == null)
    {
      sequenceNumberSpinner = new JSpinner();
      sequenceNumberSpinner.setPreferredSize(new java.awt.Dimension(50, 20));
      sequenceNumberSpinner.addChangeListener(new javax.swing.event.ChangeListener() {
        public void stateChanged(javax.swing.event.ChangeEvent e)
        {
          Integer value = (Integer) sequenceNumberSpinner.getValue();

          getTupleEditor().getPacket().setSeqNr(value.shortValue());
          ((JSpinner) e.getSource()).setValue(new Integer(getTupleEditor()
              .getPacket().getSeqNr()));
        }
      });
      
      getTupleEditor().getPacket().addTableModelListener(new TableModelListener()
    		  {

				public void tableChanged(TableModelEvent e) {
					sequenceNumberSpinner.setValue(
							new Integer(getTupleEditor().getPacket().getSeqNr()));
				}
    	  
    		  });
    }
    return sequenceNumberSpinner;
  }

  /*
   * (non-Javadoc)
   * 
   * @see javax.swing.event.TreeSelectionListener#valueChanged(javax.swing.event.TreeSelectionEvent)
   */
  public void valueChanged(TreeSelectionEvent e)
  {
    TreePath path = e.getPath();

    if (path.getPath().length > 1 && path.getPath()[1] instanceof ParticleSrcId)
    {
      ParticleSrcId id = (ParticleSrcId) path.getPath()[1];
      getReceiverTextField().setValue(id);
    }
  }
} // @jve:decl-index=0:visual-constraint="10,10"
